# CEGUI::FrameComponent Class Reference

Class that encapsulates information for a frame with background (9 images in total). More...

Inheritance diagram for CEGUI::FrameComponent:

[legend]
Collaboration diagram for CEGUI::FrameComponent:

[legend]
List of all members.

## Public Member Functions

| FrameComponent ()
| Constructor.
VerticalFormatting | getBackgroundVerticalFormatting () const
| Return the current vertical formatting setting for this FrameComponent.
void | setBackgroundVerticalFormatting (VerticalFormatting fmt)
| Set the vertical formatting setting for this FrameComponent.
HorizontalFormatting | getBackgroundHorizontalFormatting () const
| Return the current horizontal formatting setting for this FrameComponent.
void | setBackgroundHorizontalFormatting (HorizontalFormatting fmt)
| Set the horizontal formatting setting for this FrameComponent.
const Image * | getImage (FrameImageComponent part) const
| Return the Image object that will be drawn by this FrameComponent for a specified frame part.
void | setImage (FrameImageComponent part, const Image *image)
| Set the Image that will be drawn by this ImageryComponent.
void | setImage (FrameImageComponent part, const String &imageset, const String &image)
| Set the Image that will be drawn by this FrameComponent.
void | writeXMLToStream (OutStream &out_stream) const
| Writes an xml representation of this FrameComponent to out_stream.

## Protected Member Functions

void | render_impl (Window &srcWindow, Rect &destRect, float base_z, const CEGUI::ColourRect *modColours, const Rect *clipper, bool clipToDisplay) const
| Method to do main render caching work.
void | doBackgroundRender (Window &srcWindow, Rect &destRect, float base_z, const ColourRect &colours, const Rect *clipper, bool clipToDisplay) const

## Protected Attributes

VerticalFormatting | d_vertFormatting
| Vertical formatting to be applied when rendering the background for the component.
HorizontalFormatting | d_horzFormatting
| Horizontal formatting to be applied when rendering the background for the component.
const Image * | d_frameImages [FIC_FRAME_IMAGE_COUNT]
| Array that holds the assigned images.

## Detailed Description

Class that encapsulates information for a frame with background (9 images in total).

Corner images are always drawn at their natural size, edges are stretched between the corner pieces for a particular edge, the background image will cover the inner rectangle formed by the edge images and can be stretched or tiled in either dimension.

## Member Function Documentation

HorizontalFormatting CEGUI::FrameComponent::getBackgroundHorizontalFormatting | ( |  | ) | const

Return the current horizontal formatting setting for this FrameComponent.

Returns:
  One of the HorizontalFormatting enumerated values.

VerticalFormatting CEGUI::FrameComponent::getBackgroundVerticalFormatting | ( |  | ) | const

Return the current vertical formatting setting for this FrameComponent.

Returns:
  One of the VerticalFormatting enumerated values.

const Image * CEGUI::FrameComponent::getImage | ( | FrameImageComponent | part | ) | const

Return the Image object that will be drawn by this FrameComponent for a specified frame part.

Parameters:

  | part | One of the FrameImageComponent enumerated values specifying the component image to be accessed.

Returns:
  Image object.

void CEGUI::FrameComponent::setBackgroundHorizontalFormatting | ( | HorizontalFormatting | fmt | ) |

Set the horizontal formatting setting for this FrameComponent.

Parameters:

  | fmt | One of the HorizontalFormatting enumerated values.

Returns:
  Nothing.

void CEGUI::FrameComponent::setBackgroundVerticalFormatting | ( | VerticalFormatting | fmt | ) |

Set the vertical formatting setting for this FrameComponent.

Parameters:

  | fmt | One of the VerticalFormatting enumerated values.

Returns:
  Nothing.

void CEGUI::FrameComponent::setImage | ( | FrameImageComponent | part,
|  | const String & | imageset,
|  | const String & | image
| ) |

Set the Image that will be drawn by this FrameComponent.

Parameters:

  | part | One of the FrameImageComponent enumerated values specifying the component image to be accessed.
  | imageset | String holding the name of the Imagset that contains the Image to be rendered.
  | image | String holding the name of the Image to be rendered.

Returns:
  Nothing.

void CEGUI::FrameComponent::setImage | ( | FrameImageComponent | part,
|  | const Image * | image
| ) |

Set the Image that will be drawn by this ImageryComponent.

Parameters:

  | part | One of the FrameImageComponent enumerated values specifying the component image to be accessed.
  | image | Pointer to the Image object to be drawn by this FrameComponent.

Returns:
  Nothing.

void CEGUI::FrameComponent::writeXMLToStream | ( | OutStream & | out_stream | ) | const

Writes an xml representation of this FrameComponent to out_stream.

Parameters:

  | out_stream | Stream where xml data should be output.

Returns:
  Nothing.